\name{aRTlayer-getMetric}

\docType{object}

\alias{getMetric,aRTlayer-method}
\alias{getMetric}
\alias{hull}
\alias{center}
\alias{area}
\alias{centroid}
\alias{length}

\usage{
\S4method{getMetric}{aRTlayer}(object, metric, distance)
}

\title{getMetric}

\description{Returns some spatial operation that is not stored in the layer.
It rerurns the result of this operation over each element.}

\arguments{
  \item{object}{Object of class \code{aRTlayer}.}
  \item{metric}{One metric among:
   \itemize{
	  \item area
	  \item length
	  \item centroid
	  \item hull
	  \item buffer
   }
  }	
  \item{distance}{The distance, used only with buffer.}
}

\examples{
\dontrun{
getMetric(layer, "hull")
getMetric(layer, "buffer", dist=500)
}}

\author{Pedro Ribeiro de Andrade Neto}
\keyword{connection}

\seealso{
   See \code{aRTlayer-class} to the description of this class.
}

% vim: syntax=tex
