\name{aRTlayer-getSetMetric}

\docType{object}

\alias{getSetMetric,aRTlayer-method}
\alias{getSetMetric}
\alias{union}
\alias{difference}
\alias{xor}
\alias{intersection}

\title{Set Metrics}

\description{
  Return the result of a metric evolving set operations (union, intersection, difference and xor).
}

\usage{
\S4method{getSetMetric}{aRTlayer}(object, metric, ids=c("1","2","3"))
}

\arguments{
  \item{object}{Object of class \code{aRTlayer}.}
  \item{metric}{A set metric among:}
  \itemize{
  	\item union
  	\item intersection
  	\item difference
  	\item xor
  }
  \item{ids}{The ids which to be used in the operation. Metrics \code{difference} and \code{xor}
  use only two ids.}
}

\examples{
\dontrun{
## difference between two geometries
getSetMetric(layer, "difference", ids=c("1", "2"))

## union of all geometries of the layer
getSetMetric(layer, "union", ids=getGeometry(layer)$id)
}
}

\keyword{connection}
\author{Pedro Ribeiro de Andrade Neto}

\seealso{
   See \code{aRTlayer-class} to the description of this class.
}

% vim: syntax=tex
